% Distributions
clear;
% ---- Coin flip Distribution ----
numCoins = 1;
trials = 10;
n=1:trials;
heads = fix(2*rand(numCoins,trials));  %Round towards zero
addColumns = ones(1,numCoins);
randomSample = addColumns*heads;
relFreq = cumsum(randomSample)./n;

figure(1)
    range = numCoins + 1;
	plot(randomSample, '*')
    hold on
    plot(relFreq, '.r')
    hold off
    axis([1 trials -1 range]);
    title('Sample set')       
    xlabel('trial')
    ylabel('Sample value')
    grid on

figure(2)
    binWidth = 1;
    x = -range:binWidth:range;
    histogram = histc(randomSample, x);
    bar(x, histogram/trials)
    xlim([-1 range])
    title('Probability distribution')       
    xlabel('x')
    ylabel('P(x)')
 