% Distributions
clear;
% ---- Dice Roll Distribution ----
numDice = 2;
trials = 100;
n=1:trials;
die = fix(6*(rand(numDice,trials))+1);
addColumns = ones(1,numDice);
randomSample = addColumns*die;
lucky7 = find(randomSample==7);
relFreq = zeros(1,trials);
relFreq(lucky7) = 1;
relFreq = cumsum(relFreq)./n;
expectation = ones(1,trials);
stdev = ones(1,trials);
stdev = std(randomSample)*stdev;
expectation(1,:) = mean(randomSample(1,:));
figure(1)
    range = 6*numDice;
	plot(randomSample, '*')
    hold on
    plot(relFreq, '.r')
    plot(expectation, '-r')
    plot(expectation+stdev, '--g')
    plot(expectation-stdev, '--g')
    hold off
    axis([0 trials 0 range]);
    title('Sample set')       
    xlabel('trial')
    ylabel('Sample value')
    grid on
    
figure(2)
    binWidth = 0.5;
    x = -range:binWidth:range;
    histogram = histc(randomSample, x);
    bar(x, histogram/trials)
    hold on
    plot( [expectation(1) expectation(1)], [0 1], '-r')
    plot( [expectation(1)-stdev(1) expectation(1)-stdev(1)], [0 1], '--g')
    plot( [expectation(1)+stdev(1) expectation(1)+stdev(1)], [0 1], '--g')
    hold off
    xlim([1 range+1])
    title('Probability distribution')       
    xlabel('x')
    ylabel('P(x)')
 