% Distributions
clear;

if 1==1
% ---- Bernoulli Trials ----
n = 1;
p = 0.5;   % 0 < p < 0.5
samples = 10;
run =1:samples;
success = fix(2*(rand(n,samples)-(0.5-p)));
addColumns = ones(1,n);
randomSample = addColumns*success;
relFreq = cumsum(randomSample)./run;
expectation = ones(1,samples);
expectation(1,:) = mean(randomSample(1,:));
stdev = ones(1,samples);
stdev = std(randomSample)*stdev;

%binomial distribution
   k = [0:1:n];
   C_nk = gamma(n+1)./(gamma(k+1).*gamma(n-k+1) );
   Pk = C_nk.*p.^k.*(1-p).^(n - k);
%Gaussian function
    z = -n:0.1:n;
    sigma = sqrt(n*p*(1-p));
    gauss = exp(-((z-n/2).^2)/(2*sigma^2))/(sigma*sqrt(2*pi));

range = n + 1;
k =0:n;

figure(1)
	plot(randomSample, '*')
    hold on
    plot(relFreq, '.r')
    plot(expectation, '-r')
    plot(expectation+stdev, '--g')
    plot(expectation-stdev, '--g')
    hold off
    axis([1 samples -1 range]);
    title('Bernoulli samples')       
    xlabel('run')
    ylabel('Sample value')
    grid on

figure(2)
    binWidth = 1;
    x = -range:binWidth:range;
    histogram = histc(randomSample, x);
    bar(x, histogram/samples)
    hold on
    stem(k,Pk, 'r')
    plot(z,gauss, '-g')
    hold off
    xlim([-1 range])
    title('Probability distribution')       
    xlabel('k')
    ylabel('P(k)')
  
else
% ---- Gaussian (Normal) Distribution ----
samples = 10000;
randomSample = 2*randn(1,samples);
expectation = ones(1,samples);
expectation(1,:) = mean(randomSample(1,:));
stdev = ones(1,samples);
stdev = std(randomSample)*stdev;

range = 8;
%Gaussian function
    z = -range:0.1:range;
    sigma = std(randomSample);
    gauss = exp(-(z.^2)/(2*sigma^2))/(sigma*sqrt(2*pi));
    
figure(1)
	plot(randomSample, '*')
    hold on
    plot(expectation, '.r')
    plot(stdev, '--g')
    plot(-stdev, '--g')
    hold off
    axis([0 samples -range range]);
figure(2)
    binWidth = 1;
    x = -range:binWidth:range;
    histogram = hist(randomSample, x);
    stem(x, histogram/samples, 'fill')
    hold on
    plot(z,gauss, '-g')
    hold off
    xlim([-range range])
end